//Made by Piexes BL_ID 26520
function servercmdShadowMute(%client, %n0, %n1, %n2, %n3, %n4, %n5, %n6, %n7)
{
	if(!%client.isAdmin)
	{
		%client.chatMessage("\c3You cannot use this command since you are not an admin.");
		return;
	}
	if(%n0 $= "")
	{
		%client.chatMessage("\c3You need to specify a person to shadow mute.");
		%client.chatMessage("\c3Shadow mute mutes the target, so that other people don't see their chat.");
		%client.chatMessage("\c3This is different from a regular mute though, since in this version they don't realize they are muted.");
		%client.chatMessage("\c3Everything that they type still shows up for them in their chat.");
		return;
	}
	%target = %n0;
	for(%i=1; %n[%i + 1] !$= ""; %i++)
		%target = %target SPC %n[%i];
	%time = %n[%i];
	if(!strLen(%time) || %time + 0 !$= %time)
	{
		%client.chatMessage("\c3You need to specify the amount of time you want this person to be muted.");
		%client.chatMessage("\c3You put it after the name of the person you want to shadowmute. The time is measured in seconds.");
		return;
	}
	if(%time <= 0 || %time > 9999)
	{
		%client.chatMessage("\c3That isn't a valid amount of time to mute someone.");
		return;
	}
	talk(%target);
	%target = findclientbyname(%target);
	if(%target $= "" || %target == 0)
	{
		%client.chatMessage("\c3That client could not be found.");
		return;
	}
	if(%client == %target)
	{
		%client.chatMessage("\c3You cannot shadow mute yourself!");
		//return;
	}
	if(%target.isAdmin)
	{
		%client.chatMessage("\c3You cannot shadow mute admins.");
		//return;
	}
	%target.isShadowMuted = 1;
	%client.chatMessage("\c3To unmute this person, do /shadowunmute personsname.");
	%time *= 1000;
	%target.shadowmuteschedule = schedule(%time, 0, SUnmute, %target);
	%c = ClientGroup.getCount();
	for(%i=0;%i<%c;%i++)
	{
		%tClient = ClientGroup.getObject(%i);
		if(%tClient.isAdmin)
		{
			%time = %time / 1000;
			%client.chatMessage("\c3[ADMIN]\c6: The user" SPC %client.name SPC "has been shadow muted for" SPC %time SPC "seconds by" SPC %client.name @ ".");
		}
	}
}
function servercmdShadowUnmute(%client, %n0, %n1, %n2, %n3, %n4, %n5, %n6)
{
	if(!%client.isAdmin)
	{
		%client.chatMessage("\c3You don't have access to this command.");
		return;
	}
	if(%n0 $= "")
	{
		%client.chatMessage("\c3You need to specify someone to unmute!");
	}
	%target = %n0;
	for(%i=1;%n[%i+1] !$= ""; %i++)
		%target = %target SPC %n[%i];
	%target = findclientbyname(%target);
	if(%target $= "")
	{
		%client.chatMessage("\c3That client could not be found.");
		return;
	}
	if(%client == %target)
	{
		%client.chatMessage("\c3You can't unmute yourself.");
		return;
	}
	if(%target.isShadowMuted $= "" || %target.isShadowMuted == 0)
	{
		%client.chatMessage("\c3That client isn't shadow muted!");
		return;
	}
	%client.chatMessage("\c3Client successfully un-shadow-muted.");
	SUnmute(%target);
}
package ShadowMute
{
	function servercmdMessageSent(%client, %msg)
	{
		%cl = %client;
		if(%cl.isShadowMuted)
		{
			//Credit for the following snippet goes to the creator of the colored names add-on.
			%msg  = stripMLControlChars(trim(%msg));
			%cnt  = getWordCount(%msg);
			%spam = %cl.isSpamming;
			%time = getSimTime();
			// Remaking chat so we need to block words
			if($Pref::Server::ETardFilter)
			{
				%filter = strReplace($Pref::Server::ETardList,",","\t");
				%count  = getFieldCount(%filter);
				
				for(%i = 0; %i < %count; %i++)
				{
					%word = getField(%filter,%i);
					
					// This will check space-requiring filters
					if(strPos(" " @ %msg @ " ",%word) != -1)
					{
						messageClient(%cl,'',"\c5This is a civilized game. Please use full words.");
						return;
					}
				}
			}
			
			if(%msg $= %cl.lastChatText && %time - %cl.lastChatTime < 15000)
			{
				// An admin gets sent this warning message
				messageClient(%cl,'',"\c5Do not repeat yourself.");
				
				if(!%cl.isAdmin && !%spam)
				{
					// They get flood protected for 10 seconds
					%cl.isSpamming       = 1;
					%cl.spamProtectStart = %time;
					
					schedule(10000,0,eval,%cl @ ".isSpamming = 0;");
				}
			}
			
			if(!%cl.isAdmin && !%spam)
			{
				if(%cl.spamMessageCount == 4)
				{
					// They get flood protected for 10 seconds
					%cl.isSpamming       = 1;
					%cl.spamProtectStart = %time;
					
					schedule(10000,0,eval,%cl @ ".isSpamming = 0;");
				}
				else
				{
					// They can only send four lines every 10s
					%cl.spamMessageCount++;
					schedule(10000,0,eval,%cl @ ".spamMessageCount--;");
				}
			}
			
			// Tells them that they're spamming
			if(%cl.isSpamming)
			{
				spamAlert(%cl);
				return;
			}
			
			// Remaking chat so we need to parse links
			for(%i = 0; %i < %cnt; %i++)
			{
				%word = getWord(%msg,%i);
				%end  = getSubStr(%word,7,strLen(%word));
				
				// Added in check for ":" which broke tags
				if(getSubStr(%word,0,7) $= "http://" && strPos(%end,":") == -1)
					%word = "<a:" @ %end @ ">" @ %end @ "</a>\c6";
				
				if(%i) %new = %new SPC %word;
				else   %new = %word;
				%msg = setWord(%msg, %i, %word);
			}
			%client.chatMessage("\c7" @ %client.ClanPrefix @ "\c3" @ %client.name @ "\c7" @ %client.clanSuffix @ "\c6:" SPC %msg);
			echo("[SM]" SPC %client.name @ ":" SPC %msg);
			return;
		}
		parent::servercmdMessageSent(%Client, %msg);
	}
	function servercmdteamMessageSent(%client, %msg)
	{
		%cl = %client;
		if(%cl.isShadowMuted)
		{
			//Credit for the following snippet goes to the creator of the colored names add-on.
			%msg  = stripMLControlChars(trim(%msg));
			%cnt  = getWordCount(%msg);
			%spam = %cl.isSpamming;
			%time = getSimTime();
			// Remaking chat so we need to block words
			if($Pref::Server::ETardFilter)
			{
				%filter = strReplace($Pref::Server::ETardList,",","\t");
				%count  = getFieldCount(%filter);
				
				for(%i = 0; %i < %count; %i++)
				{
					%word = getField(%filter,%i);
					
					// This will check space-requiring filters
					if(strPos(" " @ %msg @ " ",%word) != -1)
					{
						messageClient(%cl,'',"\c5This is a civilized game. Please use full words.");
						return;
					}
				}
			}
			
			if(%msg $= %cl.lastChatText && %time - %cl.lastChatTime < 15000)
			{
				// An admin gets sent this warning message
				messageClient(%cl,'',"\c5Do not repeat yourself.");
				
				if(!%cl.isAdmin && !%spam)
				{
					// They get flood protected for 10 seconds
					%cl.isSpamming       = 1;
					%cl.spamProtectStart = %time;
					
					schedule(10000,0,eval,%cl @ ".isSpamming = 0;");
				}
			}
			
			if(!%cl.isAdmin && !%spam)
			{
				if(%cl.spamMessageCount == 4)
				{
					// They get flood protected for 10 seconds
					%cl.isSpamming       = 1;
					%cl.spamProtectStart = %time;
					
					schedule(10000,0,eval,%cl @ ".isSpamming = 0;");
				}
				else
				{
					// They can only send four lines every 10s
					%cl.spamMessageCount++;
					schedule(10000,0,eval,%cl @ ".spamMessageCount--;");
				}
			}
			
			// Tells them that they're spamming
			if(%cl.isSpamming)
			{
				spamAlert(%cl);
				return;
			}
			
			// Remaking chat so we need to parse links
			for(%i = 0; %i < %cnt; %i++)
			{
				%word = getWord(%msg,%i);
				%end  = getSubStr(%word,7,strLen(%word));
				
				// Added in check for ":" which broke tags
				if(getSubStr(%word,0,7) $= "http://" && strPos(%end,":") == -1)
					%word = "<a:" @ %end @ ">" @ %end @ "</a>\c6";
				
				if(%i) %new = %new SPC %word;
				else   %new = %word;
				%msg = setWord(%msg, %i, %word);
			}
			%client.chatMessage("\c7" @ %client.ClanPrefix @ "\c3" @ %client.name @ "\c7" @ %client.clanSuffix @ "\c4:" SPC %msg);
			echo("(T)[SM]" SPC %client.name @ ":" SPC %msg);
			return;
		}
		parent::servercmdteamMessageSent(%client, %msg);
	}
};
activatePackage(ShadowMute);

function SUnmute(%client)
{
	echo(%client.name SPC "has been un-shadowmuted.");
	%client.isShadowMuted = "";
	cancel(%client.shadowMuteSchedule);
	%client.shadowMuteSchedule = "";
}